package com.example.android_22_1_ex1;

import android.os.*;
import android.support.v7.app.*;
import android.util.*;
import android.view.*;
import android.view.View.OnClickListener;
import android.widget.*;

public class MainActivity extends ActionBarActivity {

	final static String TAG = "MainActivity";
	
	private int mainNum;
	private int secondNum;
	private TextView tvMain, tvSecond;
	private Button btnStart;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);

		tvMain = (TextView) findViewById(R.id.tv_main_thread);
		tvSecond = (TextView) findViewById(R.id.tv_second_thread);
		btnStart = (Button) findViewById(R.id.bt_start);

		btnStart.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				startNum();
			}
		});

	}
	
	private void startNum(){
		mainNum++;
		tvMain.setText("mainNum : " + mainNum);
		
		NewThread newThread = new NewThread(mainHandler, secondNum);
		newThread.setDaemon(true);
		newThread.start();
		
	}

	Handler mainHandler = new Handler() {
		public void handleMessage(Message msg) {
			if (msg.what == NewThread.NEWTHREAD_WHAT) {
				secondNum = msg.arg1;
				tvSecond.setText("secondNum : " + secondNum);
				Log.i(TAG, "secondNum in handler : " + secondNum);
			}
		};
	};
	
	

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle action bar item clicks here. The action bar will
		// automatically handle clicks on the Home/Up button, so long
		// as you specify a parent activity in AndroidManifest.xml.
		int id = item.getItemId();
		if (id == R.id.action_settings) {
			return true;
		}
		return super.onOptionsItemSelected(item);
	}
}
