package com.example.android_22_2_ex1;

import android.support.v7.app.ActionBarActivity;
import android.os.*;
import android.view.*;
import android.view.View.OnClickListener;
import android.widget.*;

public class MainActivity extends ActionBarActivity {

	TextView tvSound;
	Button btnPiano, btnGuitar, btnDrum;
	InstrumentSound instrumentSound;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);

		tvSound = (TextView) findViewById(R.id.tv_sound);
		btnPiano = (Button) findViewById(R.id.bt_conversion_piano);
		btnGuitar = (Button) findViewById(R.id.bt_conversion_guitar);
		btnDrum = (Button) findViewById(R.id.bt_conversion_drum);

		btnPiano.setOnClickListener(listener);
		btnGuitar.setOnClickListener(listener);
		btnDrum.setOnClickListener(listener);

		instrumentSound = new InstrumentSound(mHandler);
		instrumentSound.setDaemon(true);
		instrumentSound.start();

	}

	Handler mHandler = new Handler() {
		public void handleMessage(Message msg) {
			String str = "";
			switch (msg.what) {
			case InstrumentSound.SOUND_PIANO:
				Toast.makeText(MainActivity.this, "피아노소리로 전환 완료", Toast.LENGTH_SHORT).show();
				str = (String) msg.obj;
				break;

			case InstrumentSound.SOUND_GUITAR:
				Toast.makeText(MainActivity.this, "기타소리로 전환 완료", Toast.LENGTH_SHORT).show();
				str = (String) msg.obj;
				break;

			case InstrumentSound.SOUND_DRUM:
				Toast.makeText(MainActivity.this, "드럼소리로 전환 완료", Toast.LENGTH_SHORT).show();
				str = (String) msg.obj;
				break;
			}
			tvSound.setText(str);
		};
	};

	OnClickListener listener = new OnClickListener() {
		Message msg;
		@Override
		public void onClick(View v) {
			// TODO Auto-generated method stub
			switch (v.getId()) {
			case R.id.bt_conversion_piano:
				msg = Message.obtain();
				msg.what = InstrumentSound.SOUND_PIANO;
				
				break;

			case R.id.bt_conversion_guitar:
				msg = Message.obtain();
				msg.what = InstrumentSound.SOUND_GUITAR;
				break;
			case R.id.bt_conversion_drum:
				msg = Message.obtain();
				msg.what = InstrumentSound.SOUND_DRUM;
				break;
			}
			
			instrumentSound.getHandler().sendMessage(msg);
		}
	};

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle action bar item clicks here. The action bar will
		// automatically handle clicks on the Home/Up button, so long
		// as you specify a parent activity in AndroidManifest.xml.
		int id = item.getItemId();
		if (id == R.id.action_settings) {
			return true;
		}
		return super.onOptionsItemSelected(item);
	}
}
